# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(k, n) = map(int, fi.readline().strip().split())
if 1 > k or k > 20:
	sys.exit('K out of range')
if 1 > n or n > 1000000:
	sys.exit('N out of range')
fo.write('{0} {1}\n'.format(k, n))

for i in range(n):
	(t, c) = map(int, fi.readline().strip().split())
	if 1 > t or t > 2:
		sys.exit('T[{0}] out of range'.format(1 + i))
	if 0 > c or c > 2**k - 1:
		sys.exit('C[{0}] out of range'.format(1 + i))
	if t == 2 and i == 0:
		sys.exit('find: empty palette')
	fo.write('{0} {1}\n'.format(t, c))

fi.close()
fo.close()
