// This is the grader used for evaluation on the server

import java.io.*;
import java.util.*;

public class grader {

	static int bits(int m) {
		m = (m & 0x55555555) + ((m >> 1) & 0x55555555);
		m = (m & 0x33333333) + ((m >> 2) & 0x33333333);
		m = (m & 0x0f0f0f0f) + ((m >> 4) & 0x0f0f0f0f);
		m = (m & 0x00ff00ff) + ((m >> 8) & 0x00ff00ff);
		m = (m & 0x0000ffff) + ((m >> 16) & 0x0000ffff);
		return m;
	}

	public static void main(String[] args) throws IOException {
		BufferedReader sis = new BufferedReader(new FileReader("palsis.txt"));
		PrintWriter val = new PrintWriter(new FileWriter("palval.txt"));
		StringTokenizer st = new StringTokenizer(sis.readLine());
		int k = Integer.parseInt(st.nextToken());
		int n = Integer.parseInt(st.nextToken());
		pal.init(k, n);
		boolean[] p = new boolean[1 << k];
		int s = 0;
		for (int i = 0; i < n; ++i) {
			st = new StringTokenizer(sis.readLine());
			int t = Integer.parseInt(st.nextToken());
			int c = Integer.parseInt(st.nextToken());
			if (t == 1) {
				pal.add(c);
				p[c] = true;
			}
			if (t == 2) {
				int r = pal.find(c);
				if (r < 0 || r >= (1 << k) || !p[r]) {
					// contestant returned color not in palette
					val.println(-1);
					val.close();
					return;
				}
				// similarity of contestant's response to the request
				s += k - bits(r ^ c);
			}
		}
		pal.done();
		val.println(s);
		val.close();
		return;
	}

}
