# This is the grader used for evaluation on the server

import pal

def main():
	sis = open('palsis.txt', 'rt')
	val = open('palval.txt', 'wt')
	(k, n) = map(int, sis.readline().strip().split())
	pal.init(k, n)
	p = [False] * (2 ** k)
	s = 0
	for i in range(n):
		(t, c) = map(int, sis.readline().strip().split())
		if t == 1:
			pal.add(c)
			p[c] = True
		if t == 2:
			r = pal.find(c)
			if r < 0 or r >= (2 ** k) or not p[r]:
				# contestant returned color not in palette
				val.write('{0}\n'.format(-1))
				val.close()
				return
			m = r ^ c
			# compute number of bits in m
			m = (m & 0x55555555) + ((m >> 1) & 0x55555555)
			m = (m & 0x33333333) + ((m >> 2) & 0x33333333)
			m = (m & 0x0f0f0f0f) + ((m >> 4) & 0x0f0f0f0f)
			m = (m & 0x00ff00ff) + ((m >> 8) & 0x00ff00ff)
			m = (m & 0x0000ffff) + ((m >> 16) & 0x0000ffff)
			# similarity of contestant's response to the request
			s += k - m
	pal.done()
	val.write('{0}\n'.format(s))
	val.close()
	sis.close()

main()
