#include "pal.h"

#include <vector>
using namespace std;

vector<char> dist;
vector<int> best;
vector<int> q;
int K;

void init(int k, int n) {
	dist.resize(1 << k, k + 1);
	best.resize(1 << k, -1);
	q.reserve(1 << k);
	K = k;
}

void add(int c) {
	q.clear();
	dist[c] = 0;
	best[c] = c;
	q.push_back(c);
	for (int i = 0; i < q.size(); ++i) {
		for (int j = 0; j < K; ++j) {
			int next = q[i] ^ (1 << j);
			if (dist[next] > dist[q[i]] + 1) {
				q.push_back(next);
				dist[next] = dist[q[i]] + 1;
				best[next] = best[q[i]];
			}
		}
	}
}

int find(int c) {
	return best[c];
}

void done() {
}
