# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m, k) = map(int, fi.readline().strip().split())
if 2 > n or n > 300000:
	sys.exit('N out of range')
if 1 > m or m > 300000:
	sys.exit('M out of range')
if 1 > k or k > 1000000000:
	sys.exit('K out of range')
fo.write('{0} {1} {2}\n'.format(n, m, k))

aa = map(int, fi.readline().strip().split())
if len(aa) <> n:
	sys.exit('Wrong number of A values')
for i, a in enumerate(aa):
	if 1 > a or a > k:
		sys.exit('A[{0}] out of range'.format(1 + i))
fo.write('{0}\n'.format(' '.join(map(str, aa))))

pp = map(int, fi.readline().strip().split())
if len(pp) <> n - 2:
	sys.exit('Wrong number of P values')
for i, p in enumerate(pp):
	if 1 > p or p > 2 + i:
		sys.exit('P[{0}] out of range'.format(1 + i))
fo.write('{0}\n'.format(' '.join(map(str, pp))))

for i in range(m):
	(x, y) = map(int, fi.readline().strip().split())
	if 1 > x or x > n:
		sys.exit('X[{0}] out of range'.format(1 + i))
	if 1 > y or y > k:
		sys.exit('Y[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(x, y))

fi.close()
fo.close()
