// Inefficient solution to verify tests and graders
// Rename to pal.java before compiling

public class pal {

	static int[] p;
	static int m;

	static int bits(int m) {
		int b = 0;
		while (m > 0) {
			b += m & 1;
			m >>= 1;
		}
		return b;
	}

	public static void init(int k, int n) {
		p = new int[n];
		m = 0;
	}

	public static void add(int c) {
		p[m] = c;
		++m;
	}

	public static int find(int c) {
		int r = p[0];
		for (int i = 1; i < m; ++i) {
			if (bits(r ^ c) > bits(p[i] ^ c)) {
				r = p[i];
			}
		}
		return r;
	}

	public static void done() {
	}

}
