// Rename to pal.java before compiling

public class pal {

	static int K;
	static int[] dist;
	static int[] best;
	static int[] q;

	public static void init(int k, int n) {
		K = k;
		dist = new int[1 << k];
		best = new int[1 << k];
		q = new int[1 << k];
		for(int i = 0; i < (1 << k); i++) {
			dist[i] = k + 1;
		}
	}

	public static void add(int c) {
		if (dist[c] > 0) {
			int q1 = 0, q2 = 0;
			q[q1++] = c;
			dist[c] = 0;
			best[c] = c;
			for (; q1 > q2; ++q2)	{
				for (int j = 0; j < K; ++j)	{
					int v = q[q2] ^ (1 << j);
					if (dist[v] > dist[q[q2]] + 1) {
						dist[v] = dist[q[q2]] + 1;
						best[v] = c;
						q[q1++] = v;
					}
				}
			}
		}
	}

	public static int find(int c) {
		return best[c];
	}

	public static void done() {
	}

}
